/*
 * Copyright (C) 2004-2012 Geometer Plus <contact@geometerplus.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include <tqvbox.h>
#include <tqpushbutton.h>

#include <ZLDialogManager.h>

#include "ZLTQtDialog.h"
#include "ZLTQtDialogContent.h"
#include "ZLTQtUtil.h"

ZLTQtDialog::ZLTQtDialog(const ZLResource &resource) : TQDialog(0, 0, true) {
	setCaption(::qtString(resource[ZLDialogManager::DIALOG_TITLE].value()));

	TQVBoxLayout *layout = new TQVBoxLayout(this);
	TQWidget *widget = new TQVBox(this);
	layout->add(widget);
	myTab = new ZLTQtDialogContent(widget, resource);

	myButtonGroup = new TQButtonGroup(this);
	layout->add(myButtonGroup);
	myButtonLayout = new TQGridLayout(myButtonGroup, 1, 0, 8, 6);
}

ZLTQtDialog::~ZLTQtDialog() {
}

void ZLTQtDialog::addButton(const ZLResourceKey &key, bool accept) {
	TQPushButton *button = new TQPushButton(myButtonGroup);
	button->setText(::qtButtonName(key));
	myButtons.push_back(button);
	myButtonLayout->addWidget(button, 0, myButtons.size());
	connect(button, TQ_SIGNAL(clicked()), this, accept ? TQ_SLOT(accept()) : TQ_SLOT(reject()));
}

bool ZLTQtDialog::run() {
	TQSize maxSize(0, 0);
	for (std::vector<TQButton*>::const_iterator it = myButtons.begin(); it != myButtons.end(); ++it) {
		TQSize buttonSize = (*it)->sizeHint();
		maxSize = TQSize(
			std::max(maxSize.width(), buttonSize.width()),
			std::max(maxSize.height(), buttonSize.height())
		);	
	}
	for (std::vector<TQButton*>::iterator it = myButtons.begin(); it != myButtons.end(); ++it) {
		(*it)->setFixedSize(maxSize);
	}
	((ZLTQtDialogContent*)myTab)->close();
	return exec();
}
